<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDispatcherResult_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfDispatcherResult_V3 extends AbstractStructArrayBase
{
    /**
     * The DispatcherResult_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DispatcherResult_V3[]
     */
    public $DispatcherResult_V3;
    /**
     * Constructor method for ArrayOfDispatcherResult_V3
     * @uses ArrayOfDispatcherResult_V3::setDispatcherResult_V3()
     * @param \StructType\DispatcherResult_V3[] $dispatcherResult_V3
     */
    public function __construct(array $dispatcherResult_V3 = array())
    {
        $this
            ->setDispatcherResult_V3($dispatcherResult_V3);
    }
    /**
     * Get DispatcherResult_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DispatcherResult_V3[]|null
     */
    public function getDispatcherResult_V3()
    {
        return isset($this->DispatcherResult_V3) ? $this->DispatcherResult_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDispatcherResult_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDispatcherResult_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDispatcherResult_V3ForArrayConstraintsFromSetDispatcherResult_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDispatcherResult_V3DispatcherResult_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfDispatcherResult_V3DispatcherResult_V3Item instanceof \StructType\DispatcherResult_V3) {
                $invalidValues[] = is_object($arrayOfDispatcherResult_V3DispatcherResult_V3Item) ? get_class($arrayOfDispatcherResult_V3DispatcherResult_V3Item) : sprintf('%s(%s)', gettype($arrayOfDispatcherResult_V3DispatcherResult_V3Item), var_export($arrayOfDispatcherResult_V3DispatcherResult_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DispatcherResult_V3 property can only contain items of type \StructType\DispatcherResult_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DispatcherResult_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DispatcherResult_V3[] $dispatcherResult_V3
     * @return \ArrayType\ArrayOfDispatcherResult_V3
     */
    public function setDispatcherResult_V3(array $dispatcherResult_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($dispatcherResult_V3ArrayErrorMessage = self::validateDispatcherResult_V3ForArrayConstraintsFromSetDispatcherResult_V3($dispatcherResult_V3))) {
            throw new \InvalidArgumentException($dispatcherResult_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($dispatcherResult_V3) || (is_array($dispatcherResult_V3) && empty($dispatcherResult_V3))) {
            unset($this->DispatcherResult_V3);
        } else {
            $this->DispatcherResult_V3 = $dispatcherResult_V3;
        }
        return $this;
    }
    /**
     * Add item to DispatcherResult_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\DispatcherResult_V3 $item
     * @return \ArrayType\ArrayOfDispatcherResult_V3
     */
    public function addToDispatcherResult_V3(\StructType\DispatcherResult_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DispatcherResult_V3) {
            throw new \InvalidArgumentException(sprintf('The DispatcherResult_V3 property can only contain items of type \StructType\DispatcherResult_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DispatcherResult_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DispatcherResult_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DispatcherResult_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DispatcherResult_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DispatcherResult_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DispatcherResult_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DispatcherResult_V3
     */
    public function getAttributeName()
    {
        return 'DispatcherResult_V3';
    }
}
